/* Copyright 2007 You may not modify, use, reproduce, or distribute this software except in compliance with the terms of the License at:
 http://developer.sun.com/berkeley_license.html
 $Id: component.js,v 1.0 2007/04/15 19:39:59 gmurray71 Exp $
*/

jmaki.namespace("jmaki.widgets.scriptaculous.inplace");

/**
 * @constructor
 */
jmaki.widgets.scriptaculous.inplace.Widget = function(wargs) {
  
  var _widget = this;
  var _publish = "/scriptaculous/inplace";

  this.postLoad = function() {
	  if (wargs.publish) _publish = _wargs.publish;
	  init();
  };
  
  var service; 
  if (!wargs.service) {
      jmaki.log("You did need to provide a service for the completer to use. Defaulting to an _inplace.html file in the widget directory."); 
      service =  wargs.widgetDir + "/_inplace.html";
  } else service = wargs.service;

  function init() {
		_widget.wrapper = new Ajax.InPlaceEditor(wargs.uuid, service, {
			ajaxOptions : {
				method :'post'
			},
			widget :wargs,
			callback : function(form, value) {
				var result = null;
				_widget.wrapper.value = value;
				jmaki.publish(_publish + "/onValueUpdate", {
					targetId : wargs.uuid,
					value :value
				});
				if (null != wargs.outResult) {
					result = wargs.outResult;
				} else {
					result = Form.serialize(form);
					if (!wargs.service)
						_widget.wrapper.element.innerHTML = value;
					_widget.wrapper.leaveEditMode();					
				}
				return result;
			},
			onComplete : function(transport, element) {
				element.innerHTML = _widget.wrapper.value;
				if (null == transport || null == element) {
					return;
				}
				jmaki.publish(_publish + "/onComplete", {
					targetId : wargs.uuid,
					wargs :wargs,
					transport :transport,
					element :element
				});
			}
		});
		if (wargs.value) _widget.wrapper.value = wargs.value;
	}
};